/*
 * (c) Copyright 2018-2020 DESY
 *
 * This file is part of FS-DS detector software.
 *
 * This software is free: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software.  If not, see <http://www.gnu.org/licenses/>.
 *************************************************************************
 *     Author: Yuelong Yu <yuelong.yu@desy.de>
 */
#pragma once

#include <fsdetector/core/NetworkInterface.h>

#include <gmock/gmock.h>
#include <gtest/gtest.h>

namespace FSDetCoreNS
{
    class MockNetwork : public NetworkInterface
    {
      public:
        virtual ~MockNetwork(){}
        MOCK_METHOD0(Connect,int32());
        MOCK_METHOD0(Disconnect,int32());
        MOCK_METHOD0(Live,bool());
        MOCK_METHOD0(ClearDataInSocket,void());
        MOCK_METHOD1(SendData,int32(vector<uchar>));
        MOCK_METHOD2(SendData,int32(char*,szt));
        MOCK_METHOD2(ReceivePacket,int32(char*,szt&));
        MOCK_METHOD2(ReceiveData,int32(char*,szt));
        MOCK_METHOD4(ReceiveData,int32(char*,szt,szt,szt&));
    };
}

